LA 3635 - Pie 【二分】

Regionals 2006 >> Europe - Northwestern

3635 - Pie

Time limit: 3.000 seconds

My birthday is coming up and traditionally I’m

serving pie. Not just one pie, no, I have a number

N of them, of various tastes and of various sizes. F

of my friends are coming to my party and each of

them gets a piece of pie. This should be one piece

of one pie, not several small pieces since that looks

messy. This piece can be one whole pie though.

My friends are very annoying and if one of them

gets a bigger piece than the others, they start complaining.

Therefore all of them should get equally

sized (but not necessarily equally shaped) pieces,

even if this leads to some pie getting spoiled (which

is better than spoiling the party). Of course, I want

a piece of pie for myself too, and that piece should also be of the same size.

What is the largest possible piece size all of us can get? All the pies are cylindrical in shape and

they all have the same height 1, but the radii of the pies can be different.

Input

One line with a positive integer: the number of test cases. Then for each test case:

? One line with two integers N and F with 1 ≤ N, F ≤ 10000: the number of pies and the number

of friends.

? One line with N integers ri with 1 ≤ ri ≤ 10000: the radii of the pies.

Output

For each test case, output one line with the largest possible volume V such that me and my friends can

all get a pie piece of size V . The answer should be given as a oating point number with an absolute

error of at most 10?3

.

Sample Input

3

3 3

4 3 3

1 24

5

10 5

1 4 2 3 4 5 6 5 4 2

Sample Output

25.1327

3.1416

50.2655

题意:有n个pie,有f+1个人,每个人都要一整块(不是拼的)的等其他人面积的pie,求最大面积是多少。

思路:二分0~面积最大的。因为是整块分,我们只需要判断最后分的块数是不是大于等于F+1即可。

代码:

#include <cstdio>
#include <cstring>
#include <algorithm>
#include <cstring>
#include <cmath>
using namespace std;
const int M = 1e4+5;
const double Pi = acos(-1.0);

int n, f;
double s[M];

bool ok(double x){
    int sum = 0;
    for(int i = 0; i < n; ++ i) sum += floor(s[i]/x);
    if(sum >= f+1) return 1;
    return 0;
}

int main(){
    int t, v = 0;
    scanf("%d", &t);
    while(t --){
        scanf("%d%d", &n, &f);
        double temp, Max = -10000;
        for(int i = 0; i < n; ++ i){
            scanf("%lf", &temp);
            s[i] = temp*temp*Pi;
            Max = max(Max, s[i]);
        }
        double left = 0, right = Max;
        while(right - left > 1e-3){
            double mid = (right+left)/2;
            if(ok(mid)) left = mid;
            else right = mid;
        }
        printf("%.4lf\n", right);
    }
    return 0;
} 
时间: 2024-10-11 12:32:52

LA 3635 - Pie 【二分】的相关文章

LA 3635 Pie

二分答案 找到最大的圆的面积作为每个人可能分到的最大的面积. 对每个人可能分到的面积二分 验算时,求出每个pie可以切出的最大块数,然后总的块数和需要的块数比较 PS:(就是精度恶心) #include <map> #include <cmath> #include <cstdio> #include <vector> #include <string> #include <cstring> #include <algorith

【hoj】2651 pie 二分查找

二分查找是一个很基本的算法,针对的是有序的数列,通过中间值的大小来判断接下来查找的是左半段还是右半段,直到中间值的大小等于要找到的数时或者中间值满足一定的条件就返回,所以当有些问题要求在一定范围内找到一个满足一些约束的值时就可以用二分查找,时间复杂度O(log n); 题目:http://acm.hit.edu.cn/hoj/problem/view?id=2651 因为题目有精度要求,对于浮点数小数点部分会有一定误差,所以可以选择将这些有小数部分的数值扩大e6倍,因为题目要求精确到e-3,之后

POJ 3122 Pie 二分答案

Pie Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 9653   Accepted: 3478   Special Judge Description My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of v

UVALive - 3635 - Pie(二分)

题意:有F + 1(1 <= F <= 10000)个人分N(1 <= N <= 10000)个圆形派,每个人得到的派面积相同,且必须是一整块(不能够两个甚至多个派拼在一起),求每个人最多能得到多大面积的派.(误差最多到0.001) 因为答案是小数类型的,并且N高达10000,故不可暴力枚举. 可以二分枚举最大面积,然后检查是否切出来派的总个数大于等于F + 1. (判相等时不可直接判相等,需要加精度控制) #include<cstdio> #include<cs

Uva 派 (Pie,NWERC 2006,LA 3635)

依然是一道二分查找 1 #include<iostream> 2 #include<cstdio> 3 #include<cmath> 4 using namespace std; 5 6 const double PI=acos(-1.0); 7 int N,F; 8 double r[10001]; 9 10 bool ok(double area) 11 { 12 int sum=0; 13 for(int i=0;i<N;i++) 14 sum+=floo

poj 3122 Pie (二分)

<span style="background-color: rgb(255, 255, 255); font-family: Arial, Helvetica, sans-serif; font-size: 18pt;">Description</span> My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of

POJ 3122 Pie (二分+精度)

Pie Time Limit: 1000MS   Memory Limit: 65536K Total Submissions: 11240   Accepted: 3919   Special Judge Description My birthday is coming up and traditionally I'm serving pie. Not just one pie, no, I have a number N of them, of various tastes and of

HDU 1969 Pie 二分

1.题意:一项分圆饼的任务,一堆圆饼共有N个,半径不同,厚度一样,要分给F+1个人.要求每个人分的一样多,圆饼允许切但是不允许拼接,也就是每个人拿到的最多是一个完整饼,或者一个被切掉一部分的饼,要求你算出每人能分到的饼的体积最大值.输入数据依次给出,测试数据组数T,每组数据中,给出N,F,以及N个圆饼的半径.输出最大体积的数值,精确到小数点后四位. 2.分析:一看是这种输出就知道用二分写会很高效,这里对"能分出的最大体积值"进行二分.首先,这个值有界,最大值为总体积除以总人数的值,即Σ

LA 3635 派

题目链接:https://icpcarchive.ecs.baylor.edu/index.php?option=com_onlinejudge&Itemid=8&page=show_problem&problem=1636 题意: f+1个人,来分 n 个圆形派,每个人只能从一个派中拿,也就是说,不能从两个里面去拼. 求每个人最大的面积. 分析: 二分. 二分能够得到的最大面积x,怎么判断是否可以分到呢? 把每一个派分成 x,有多少份>=f+1,即可: 1 #include